#
variables:
  #
  ### Maven
  #
  # https://maven.apache.org/ref/3.8.1/maven-embedder/cli.html
  # -B,--batch-mode
  # -e,--errors
  # -s,--settings
  MAVEN_CLI_OPTIONS: "-B -e -s .m2/settings.xml -Dmaven.repo.local=.m2/repository"
  CHILD_MAVEN_CLI_OPTIONS: '-B -e -s ../.m2/settings.xml -Dmaven.repo.local=../.m2/repository'
  #
  #
  ### Docker Service
  #
  ## https://docs.gitlab.com/ee/ci/docker/using_docker_build.html
  ## TODO: Find out if we actually need this or not.
  DOCKER_DRIVER: overlay2
  #
  DOCKER_HOST: "tcp://docker:2375"
#
cache:
  paths:
    - .m2/repository
#
## Docker in Docker service is used by Testcontainers in tests and by Gitlab CI to push images to Docker Hub.
services:
  - docker:dind
#
#
stages:
  - verify
  - publish
#
verify:
  stage: verify
  image: maven:3.8.7-eclipse-temurin-17
  rules:
    - if: "$CI_COMMIT_BRANCH != 'dev' && $CI_COMMIT_BRANCH != 'master'"
      when: on_success
  script:
    #
    - java -version
    #
    - mvn $MAVEN_CLI_OPTIONS clean verify -e
  artifacts:
    reports:
      junit: "**/target/surefire-reports/TEST-*.xml"
  coverage: '/\d+\.\d+ % covered/'
#
publish:
  stage: publish
  image: maven:3.8.7-eclipse-temurin-17
  rules:
    - if: "$CI_COMMIT_BRANCH == 'dev' || $CI_COMMIT_BRANCH == 'master'"
      when: on_success
  script:
    #
    - java -version
    - mvn $MAVEN_CLI_OPTIONS help:effective-settings
    - mvn $MAVEN_CLI_OPTIONS clean install -e
    #
    - cd omniboard-one-application
    - mvn $CHILD_MAVEN_CLI_OPTIONS help:effective-settings
    - mvn $CHILD_MAVEN_CLI_OPTIONS docker:build docker:push -Pbuild-docker-image,push-to-docker-hub -e
  artifacts:
    reports:
      junit: "**/target/surefire-reports/TEST-*.xml"
  coverage: '/\d+\.\d+ % covered/'
#
